/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./analyseurLexical.cpp and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "analyseurLexical.h"

AnalyseurLexical::AnalyseurLexical() : QObject(){
}

void AnalyseurLexical::afficherCC(){
    list<Lexeme>::iterator i;
    string ts;
    for(i=cc.begin();i!=cc.end();++i){
      ts="";
      ts+=(*i).type;
      ts+=" : '";
      ts+=(*i).v;
      ts+="'";
      std::cout<<ts<<std::endl;
    }
    
}

char AnalyseurLexical::avancer(){
	return fichier[posFic++];
}

void AnalyseurLexical::analyser(string fic){
	fichier = fic;
  int nbL=1;
  int nbC =1;
  posFic=0;
  char n;
  n = avancer();
  resetCC();
  while(posFic<=fic.length()){
    string mot="";
    if(n=='\t' || n==' '){
      ++nbC;
      n = avancer();
    }else if(n=='\n'){
      ++nbL;
      nbC=1;
      n = avancer();
    }else if(((n>='a') && (n<='z')) || ((n>='A') && (n<='Z'))){ // Debut d'un mot
      
      mot+=n;
      //++nbC;
      n = avancer();
      while(((n>='a') && (n<='z')) || ((n>='A') && (n<='Z')) || (n>='0' && n<='9')){
        mot+=n;
        ++nbC;
        n = avancer();
      }
      if(motCle(mot)==1){
        ajouterLexeme(nbL,nbC,"MotCle",mot);
      }else{
        ajouterLexeme(nbL,nbC,"Identificateur",mot);
      }
      ++nbC;
    }else if(n>='0' && n<='9'){ // Debut d'un nombre
      mot+=n;
      ++nbC;
      n = avancer();
      while(n>='0' && n<='9'){
        mot+=n;
        ++nbC;
        n = avancer();
      }
        ajouterLexeme(nbL,nbC-1,"Nombre",mot);
        //n = avancer();
    }else if(n=='/'){
      mot+=n;
      ++nbC;
      n = avancer();
      if(n=='/'){   // COMMENTAIRE
        ++nbC;
        n = avancer();
        while(n!='\n'){
          ++nbC;
          n = avancer();
        }
      }else{
        ajouterLexeme(nbL,nbC,"Caractere",mot[0]);
      }
    }else if(n=='<' || n=='>' || n=='=' || n=='!' ||n=='+'){
      mot+=n;
      ++nbC;
      n = avancer();
      if(n=='='){
        mot+=n;
        ++nbC;
        n = avancer();
        ajouterLexeme(nbL,nbC,"MotCle",mot);
      }else{
        ajouterLexeme(nbL,nbC-1,"Caractere",mot);
      }
      
    }else{
      ajouterLexeme(nbL,nbC,"Caractere",n);
      ++nbC;
      n = avancer();
    }
    //semaphore->acquire(1);
  }
	ajouterLexeme(nbL,nbC,"FIN","FIN");
}


void AnalyseurLexical::resetCC(){
  cc.clear();
}





int AnalyseurLexical::motCle(string expect){
  int i=0;
  while(i<tableMC.taille){
    if(tableMC.t[i].compare(expect)==0){
      return 1;
    }
    ++i;
  }
  return 0;
}


void AnalyseurLexical::ajouterLexeme(int l,int c,string type,string val){
  cc.insert(cc.end(),Lexeme(l,c,type,val));
  string ts;
  ts="";
  ts+=type;
  ts+=" : '";
  ts+=val;
	ts+="'";
  emit signal_newLexeme(ts);
}

void AnalyseurLexical::ajouterLexeme(int l,int c,string type,char val){
  string s ="";
  s+=val;
  //cc.insert(cc.end(),Lexeme(l,c,type,s));
  ajouterLexeme(l,c,type,s);
}


//////////////////////////////////////////////
//
//  Methodes utilisees dans l'AS
//
//////////////////////////////////////////////

int AnalyseurLexical::ccVide(){
	if(cc.empty()){
		return 1;
	}else{
		return 0;
	}
}

void AnalyseurLexical::lire(){
  cc.pop_front();
}

// Lecture d'un lexeme particulier
int AnalyseurLexical::lireMotCle(string m){
 if(((*(cc.begin())).type.compare("MotCle") == 0) && ((*(cc.begin())).v.compare(m))== 0){
   lire();
   return 1;
  }else{
    erreur(0,m);
    return 0;
  }
}

int AnalyseurLexical::lireIdentificateur(){
  if(((*(cc.begin())).type.compare("Identificateur"))==0){
    lire();
    return 1;
  }else{
    erreur(1,"");
    return 0;
  }
}


int AnalyseurLexical::lireCaractere(string m){
  if(((*(cc.begin())).type.compare("Caractere")==0) && ((*(cc.begin())).v.compare(m)==0)){
    lire();
    return 1;
  }else{
    erreur(2,m);
    return 0;
  }
}


int AnalyseurLexical::voirMotCle(string m){
   if(((*(cc.begin())).type.compare("MotCle") == 0) && ((*(cc.begin())).v.compare(m))== 0){
     return 1;
  }else{
    return 0;
  }
}

int AnalyseurLexical::voirCaractere(string m){   
   if(((*(cc.begin())).type.compare("Caractere") == 0) && ((*(cc.begin())).v.compare(m))== 0){
     return 1;
  }else{
    return 0;
  }
}

int AnalyseurLexical::voirIdentificateur(){
   if(((*(cc.begin())).type.compare("Identificateur") == 0)){
     return 1;
  }else{
    return 0;
  }
}

int AnalyseurLexical::voirNombre(){
   if(((*(cc.begin())).type.compare("Nombre") == 0)){
     return 1;
  }else{
    return 0;
  }
}

string AnalyseurLexical::get(){
  return (*(cc.begin())).v;
}

void AnalyseurLexical::warning(int n,string v){
  string warn = "Attention ligne ";
  ostringstream oss;
  oss << ((*cc.begin()).ligne);
  warn += oss.str();
  warn+=" : ";
	switch(n){
    case 0 : warn+=" la variable "+v+" n'est pas initialisee";break;
    case 1 : warn+=" la variable "+v+" n'est pas utilisee";break;
	}
	emit signal_warning(warn);
}
void AnalyseurLexical::erreur(int n,string v){
  string err = "Erreur ligne ";
  ostringstream oss;
  oss << ((*cc.begin()).ligne);
  err += oss.str();
  err+=" : ";

  switch(n){
    case 0 : err+=" mot cle '"+v+"' attendu\n";break;
    case 1 : err+=" identificateur attendu\n";break;
    case 2 : err+=" caractere '"+v+"' attendu\n";break;
    case 3 : err+=" instruction incorrecte\n";break;
    case 4 : err+=" typage non respecte\n";break;
    case 5 : err+="'"+v+"' ne peut etre utilise comme nom de variable\n";break;
    case 6 : err+=" l'expression doit etre de type : "+v+"\n";break;
    case 7 : err+=" types "+v+" incompatibles\n";break;
    case 8 : err+=" variable '"+v+"' non declaree\n";break;
    case 9 : err+=" redeclaration de la variable '"+v+"'\n";break;
    case 10 : err+=" declaration d'une routine dans une routine\n";break;
    case 11 : err+=" type de retour attendu\n";break;
		case 12 : err+=" le parametre doit etre de type "+v+"\n";break;
		case 13 : err+=" le nombre de parametres est incorrect\n";break;
		case 14 : err+=" la fonction "+v+" est declaree comme procedure\n";break;
		case 15 : err+=" une procedure ne renvoie rien (meme pas void)\n";break;
		case 16 : err+=" la fonction doit retourner un "+v+"\n";break;
		case 17 : err+=" l'instruction return doit se trouver dans une fonction\n";break;
		
		default : err+=" erreur inconnue (c'est embetant...)\n";break;
  }
  throw Erreur(((*cc.begin()).ligne),((*cc.begin()).col),err);
}



int AnalyseurLexical::ligne(int i){
    list<Lexeme>::iterator it;
    it = cc.begin();
    int k = 0;
    while(k<i){
      it++;
      ++k;
    }
    return (*it).ligne;
}

int AnalyseurLexical::colonne(int i){
    list<Lexeme>::iterator it;
    it = cc.begin();
    int k = 0;
    while(k<i){
      it++;
      ++k;
    }
    return (*it).col;
}


Lexeme::Lexeme(int l,int c,string t,string val){
  ligne = l;
  col = c;
  type = t;
  v = val;
}



