/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./analyseurLexical.h and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef ALH
#define ALH

#include <list>
#include <string>
#include <stdlib.h>
#include <iostream>
#include <sstream>

#include "codeeditor.h"

#include <QSemaphore>
#include "exceptions.h"

using namespace std;


class Lexeme{
public:
  int ligne;
  int col;
  string type;
  string v;
  
  Lexeme(int,int,string,string);

};


class TableMC{
private:
public:
  string t[28];
  int taille;
  TableMC(){
    taille=28;
    t[0]="begin";
    t[1]="while";
    t[2]="if";
    t[3]="else";
    t[4]="<=";
    t[5]=">=";
    t[6]="program";
    t[7]="end";
    t[8]="routine";
    t[9]="or";
    t[10]="and";
    t[11]="==";
    t[12]="!=";
    t[13]="print";
    t[14]="scan";
    t[15]="true";
    t[16]="false";
    t[17]="fi";
    t[18]="done";
    t[19]="then";
    t[20]="elsif";
    t[21]="void";
    t[22]="integer";
    t[23]="bool";
    t[24]="do";
		t[25]="for";
		t[26]="return";
		t[27]="PA"; //ne sert que pour le debug
    
  }
};


// public:






class AnalyseurLexical : public QObject{
  Q_OBJECT
private:
  TableMC tableMC;
	unsigned posFic;
	char avancer();
	string fichier;
	
public:
  list<Lexeme> cc;
  AnalyseurLexical();
  void analyser(string);
  void afficherCC();

  void ajouterLexeme(int,int,string,string);
  void ajouterLexeme(int,int,string,char);
  void resetCC();

  int motCle(string);
  int ccVide();
  void lire();
  int lireMotCle(string);
  int lireIdentificateur();
  int lireCaractere(string);

  int voirMotCle(string);
  int voirCaractere(string);
  int voirIdentificateur();
  int voirNombre();
  
	void warning(int,string);
  void erreur(int,string);
  
  int ligne(int);
  int colonne(int);
  
  string get();
  
signals:
  void signal_newLexeme(std::string);  
	void signal_warning(std::string);
  void signal_PA();
};

#endif

