/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./analyseurSyntaxique.h and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef ASH
#define ASH
#include <QSemaphore>
#include "analyseurLexical.h"
#include "pointGeneration.h"


class AnalyseurSyntaxique{
private:
  AnalyseurLexical* al;
	int pasApas;
	QSemaphore* sem;
	string varGlo_retour; // permet de connaitre le type de retour d'une fonction
public:
  string err;
  AnalyseurSyntaxique(AnalyseurLexical*,int,QSemaphore*);
  ~AnalyseurSyntaxique();
  Generation pg;
 
  void analyser();
  int horner(string);
  vector<vector<int> > progObjet();
  //string poToString();
  
	void pointArret(string);
	void setPasApas(){
		pasApas = 1;
	}
	
	void lire();
	void lireIdentificateur();
	void lireMotCle(string);
	void lireCaractere(string);

  /*
   *  Representations regles de grammaire
  */
  void princ();
  void corpsPrinc();
  void partieDecla();
  
  void listeDecla();
  void decla();
  void listeIdent();
  void ident();
  
  void listeDeclaRoutine();
  void declaRoutine();
  void listeDeclaInSub();
  void listeParam(string);
  void param(string);
  void corps();
  
  void listeInstrs();
  void instr();
  
  string expression();
  string exprAnd();
  string exprTest();
  string exprAdd();
  string exprMult();
  
  string terminal();
  string elemTerminal();
  
  void alternatives();
  void boucleWhile();
  void boucleFor();
};

#endif
