/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./boutons.cpp and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "boutons.h"

Boutons::Boutons(QWidget* wi) : QFrame(wi){
  w = wi;
  QHBoxLayout* layout = new QHBoxLayout;

  aL = new QPushButton(tr("analyse lexicale"));
  aS = new QPushButton(tr("analyse syntaxique"));
  execution = new QPushButton(tr("execution"));
  pap = new QPushButton(tr("pas a pas"));
  reset = new QPushButton(tr("reset"));
  stop = new QPushButton(tr("stop"));


  (*aL).setCursor(Qt::PointingHandCursor);
  (*aS).setCursor(Qt::PointingHandCursor);
  (*pap).setCursor(Qt::PointingHandCursor);
  (*execution).setCursor(Qt::PointingHandCursor);
  (*reset).setCursor(Qt::PointingHandCursor);
  (*stop).setCursor(Qt::PointingHandCursor);

  layout->addWidget(aL);
  layout->addWidget(aS);
  layout->addWidget(execution);
  layout->addWidget(pap);
  layout->addWidget(reset);
  layout->addWidget(stop);

  setLayout(layout);

  QMenu *menuExec = new QMenu(tr("Execution"));

  execution->setMenu(menuExec);
  execution->setGeometry(5, 25, 200, 30);
  QAction *actionRapide = menuExec->addAction(tr("Rapide"));
  QAction *actionNormal = menuExec->addAction(tr("Normal"));
  QAction *actionLent = menuExec->addAction(tr("Lent"));
  connect(actionRapide, SIGNAL(triggered()), w, SLOT(execRapide()));
  connect(actionNormal, SIGNAL(triggered()), w, SLOT(execNormal()));
  connect(actionLent, SIGNAL(triggered()), w, SLOT(execLent()));


  connect(aL, SIGNAL(clicked()), w, SLOT(slot_lancer_AL()));
  connect(aS, SIGNAL(clicked()), w, SLOT(slot_lancer_AS()));
  connect(reset, SIGNAL(clicked()), w, SLOT(reset()));
  connect(stop, SIGNAL(clicked()), w, SLOT(stopInter()));
}
Boutons::~Boutons(){
  delete aL;
  delete aS;
  delete execution;
  delete pap;
  delete reset;
  delete stop;
}

void Boutons::activer(std::string b){
  if(b.compare("aL")==0){
    aL->setEnabled(true);
  }else if(b.compare("aS")==0){
    aS->setEnabled(true);
  }else if(b.compare("execution")==0){
    execution->setEnabled(true);
  }else if(b.compare("pap")==0){
    connect(pap, SIGNAL(clicked()), w, SLOT(slot_pap_inter()));
    pap->setEnabled(true);
  }else if(b.compare("reset")==0){
    reset->setEnabled(true);
  }else if(b.compare("stop")==0){
    stop->setEnabled(true);
  }
}

void Boutons::desactiver(std::string b){
  if(b.compare("aL")==0){
    aL->setEnabled(false);
  }else if(b.compare("aS")==0){
    aS->setEnabled(false);
  }else if(b.compare("execution")==0){
    execution->setEnabled(false);
  }else if(b.compare("pap")==0){
    disconnect(pap, SIGNAL(clicked()), w, SLOT(slot_pap_inter()));
    pap->setEnabled(false);
  }else if(b.compare("reset")==0){
    reset->setEnabled(false);
  }else if(b.compare("stop")==0){
    stop->setEnabled(false);
  }
}
