/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./constantes.h and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef CONST
#define CONST

#include <map>
#include <string>


#define MAXPILE 50

#define ADD     0
#define DEBUT 1
#define DIV     2
#define EMPILER 3
#define FIN   4
#define MULT    5
#define SUB 6
#define RESERVER 7
#define VALPILE 8
#define AFFECTATION 9
#define AND 10
#define OR  11
#define PRINT 12
#define BZE 13
#define BR 14
#define EGAL 15
#define DIFF 16
#define SUP 17
#define SUPE 18
#define INF 19
#define INFE 20
#define INVERSER 21
#define BASE 22
#define EMPILER_AS 23
#define REMPLIR 24
#define DEROUTER 25
#define REROUTER 26
#define RETURN 27
#define PA 28


class ListeInstrs{
private:
  std::map<int,std::string> instructions;
public:
  ListeInstrs(){
    instructions.insert(std::pair<int,std::string>(DEBUT,"debut"));
    instructions.insert(std::pair<int,std::string>(ADD,"add"));
    instructions.insert(std::pair<int,std::string>(DIV,"div"));
    instructions.insert(std::pair<int,std::string>(FIN,"fin"));
    instructions.insert(std::pair<int,std::string>(MULT,"mult"));
    instructions.insert(std::pair<int,std::string>(EMPILER,"empiler"));
    instructions.insert(std::pair<int,std::string>(VALPILE,"valpile"));
    instructions.insert(std::pair<int,std::string>(SUB,"sub"));
    instructions.insert(std::pair<int,std::string>(OR,"or"));
    instructions.insert(std::pair<int,std::string>(AND,"and"));
    instructions.insert(std::pair<int,std::string>(RESERVER,"reserver"));
    instructions.insert(std::pair<int,std::string>(AFFECTATION,"affectation"));
    instructions.insert(std::pair<int,std::string>(PRINT,"print"));
    instructions.insert(std::pair<int,std::string>(BZE,"bze"));
    instructions.insert(std::pair<int,std::string>(BR,"br"));
    instructions.insert(std::pair<int,std::string>(EGAL,"egal"));
    instructions.insert(std::pair<int,std::string>(DIFF,"diff"));
    instructions.insert(std::pair<int,std::string>(SUP,"sup"));
    instructions.insert(std::pair<int,std::string>(SUPE,"supe"));
    instructions.insert(std::pair<int,std::string>(INF,"inf"));
    instructions.insert(std::pair<int,std::string>(INFE,"infe"));
    instructions.insert(std::pair<int,std::string>(INVERSER,"inverser"));
		instructions.insert(std::pair<int,std::string>(BASE,"genererBase"));
		instructions.insert(std::pair<int,std::string>(EMPILER_AS,"empilerAS"));
		instructions.insert(std::pair<int,std::string>(REMPLIR,"remplirBase"));
		instructions.insert(std::pair<int,std::string>(DEROUTER,"derouter"));
		instructions.insert(std::pair<int,std::string>(REROUTER,"rerouter"));
		instructions.insert(std::pair<int,std::string>(RETURN,"return"));
		instructions.insert(std::pair<int,std::string>(PA,"PA"));
  }
  
  std::string instrs(int i){
    return instructions[i];
  }
};


#endif



