/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./exceptions.h and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef EXCEP
#define EXCEP
class Erreur : public std::exception{
private:
	int ligne;
	int colonne;
	std::string err;
public:
	Erreur(int l=0,int c=0,std::string e="") throw():ligne(l),colonne(c),err(e){}

	virtual const char* what() const throw(){
		return err.c_str();
	}

	int numLigne() const throw(){
		return ligne;
	}
	
	int numColonne() const throw(){
		return colonne;
	}
	virtual ~Erreur() throw(){}
 
};
#endif