/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./infos.cpp and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "infos.h"

Infos::Infos(QWidget* w) : QTextEdit(w){
  setReadOnly(1);
  setToolTip(tr("Affiche les differentes informations importantes\nvert : fin d'une etape\nrouge : une erreur est survenue\norange : warning\nnoir : message affiche par l'interpreteur"));
}

Infos::~Infos(){
}


void Infos::afficherSortie(std::string m){
  setTextColor(QColor("black"));
  append(QString(m.c_str()));
}

void Infos::afficherErreur(std::string m){
  setTextColor(QColor("red"));
  append(QString(m.c_str()));
}

void Infos::afficherInfo(std::string m){
  setTextColor(QColor("green"));
  append(QString(m.c_str()));
}

void Infos::afficherWarning(std::string m){
  setTextColor(QColor(255,90,1));
  append(QString(m.c_str()));
}

void Infos::reset(){
  setText("");
}
