/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./interpreteur.h and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef IH
#define IH

#include <QObject>
#include <iostream>
#include "constantes.h"
#include <sstream>
#include <vector>

using namespace std;

class Interpreteur : public QObject{
	Q_OBJECT;
private:
  vector<vector<int> > po;
  int co,ip,base;
  int pile[MAXPILE];
  int codeOp;
public:
  Interpreteur();
	~Interpreteur();
  void executer();
	void newPO(vector<vector<int> >);
signals:
	void signal_modifierPile(int,int,int);
	void signal_modifierPile(int,std::string,int);
	void signal_afficher(std::string);
	void signal_tracerFleche(int,int);
	void signal_tracerFlecheG(int,int);
	void signal_clearLigne(int);
	void signal_bougerBase(int);
	void signal_bougerCO(int);
  void signal_bougerIP(int);
	void signal_PA();
	
	
};

#endif
