/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./liste.cpp and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "liste.h"

Liste::Liste(QWidget* w) : QListView(w){
  modele = new QStandardItemModel(this);
  setModel(modele);
  setEditTriggers(0);
  setToolTip(tr("represente la chaine codee a la suite d'une analyse lexicale.\nRepresente le programme objet a la suite d'une anlyse syntaxique"));
}
Liste::~Liste(){
  modele->clear();
  delete modele;
}

void Liste::remplir(std::string ts){
  QStandardItem* qsi = new QStandardItem(QString(ts.c_str()));
  (*modele).appendRow(qsi);
}

void Liste::clear(){
  modele->clear();
}

