/*
 * Copyright (C) 2010 Dimitry Ernot <dimitry.ernot@gmail.com>
 *
 * This file ./notes.cpp and program is part of Ktopsy.
 *
 * Ktopsy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * Ktopsy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ktopsy.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "notes.h"

Notes::Notes() : QDialog(){
  setModal(true);
  text = new QTextEdit();
  text->setReadOnly(1);
  text->setToolTip(tr("Affiche différentes informations pour comprendre le fonctionnement du système"));
  resize(300,150);
  setWindowFlags(Qt::FramelessWindowHint);
}


void Notes::paintEvent(QPaintEvent *event){
  Q_UNUSED(event);
  QPainter painter(this);
  QBrush background(QColor(23, 23, 34));
  painter.setBrush(background);
  painter.setPen  (Qt::NoPen );
  painter.drawRect(0, 0, width(), height());
}

Notes::~Notes(){
  delete text;
}
